//---------------------------------------------------------------------------
//
// Name:        wxTresCRCFrm.h
// Author:      MAChF
// Created:     14/08/2007 12:53:13 p.m.
// Description: wxTresCRCFrm class declaration
//
//---------------------------------------------------------------------------

#ifndef __WXTRESCRCFRM_h__
#define __WXTRESCRCFRM_h__

#ifdef __BORLANDC__
	#pragma hdrstop
#endif

#ifndef WX_PRECOMP
	#include <wx/wx.h>
	#include <wx/frame.h>
#else
	#include <wx/wxprec.h>
#endif

//Do not add custom headers between 
//Header Include Start and Header Include End.
//wxDev-C++ designer will remove them. Add custom headers after the block.
////Header Include Start
#include <wx/filedlg.h>
#include <wx/checkbox.h>
#include <wx/spinctrl.h>
#include <wx/button.h>
#include <wx/textctrl.h>
#include <wx/stattext.h>
#include <wx/statbox.h>
#include <wx/panel.h>
#include <wx/statusbr.h>
////Header Include End

////Dialog Style Start
#undef wxTresCRCFrm_STYLE
#define wxTresCRCFrm_STYLE wxCAPTION | wxSYSTEM_MENU | wxMINIMIZE_BOX | wxCLOSE_BOX
////Dialog Style End

class wxTresCRCFrm : public wxFrame
{
	private:
		DECLARE_EVENT_TABLE();
		
	public:
		wxTresCRCFrm(wxWindow *parent, wxWindowID id = 1, const wxString &title = wxT("CRC-32 Hash Calculator for Trespasser"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxTresCRCFrm_STYLE);
		virtual ~wxTresCRCFrm();
		void Calc_CRC(wxCommandEvent& event);
		void Rev_CRC(wxCommandEvent& event);
		void TresCharSetClick(wxCommandEvent& event);
		void AlphaNumCharSetClick(wxCommandEvent& event);
		void AlphaCharSetClick(wxCommandEvent& event);
		void Crack_CRC(wxCommandEvent& event);
		void perm(unsigned int z);
		void WxButton4Click(wxCommandEvent& event);
        void revCRC(void);             
		void LeadStringUpdateUI(wxUpdateUIEvent& event);
		void TrailStringUpdateUI(wxUpdateUIEvent& event);
		void MidString2UpdateUI(wxUpdateUIEvent& event);
		void ReqString2UpdateUI(wxUpdateUIEvent& event);
		void RNDcharsUpdateUI(wxUpdateUIEvent& event);
		void CharSetUpdateUI(wxUpdateUIEvent& event);
        void reCalcStrings(void);
        void reCalcCRCs(void);
        void reCalcLengths(wxCommandEvent& event);
		void StartStringUpdateUI(wxUpdateUIEvent& event);
		void FinalStringUpdateUI(wxUpdateUIEvent& event);
		void RepeatsUpdateUI(wxUpdateUIEvent& event);
		void RepeatUpdateUI(wxUpdateUIEvent& event);
		
	private:
		//Do not add custom control declarations between
		//GUI Control Declaration Start and GUI Control Declaration End.
		//wxDev-C++ will remove them. Add custom code after the block.
		////GUI Control Declaration Start
		wxFileDialog *WxSaveFileDialog1;
		wxTextCtrl *ReqString2;
		wxStaticText *WxStaticText14;
		wxSpinCtrl *Repeats;
		wxCheckBox *Repeat;
		wxCheckBox *Strict;
		wxStaticText *WxStaticText12;
		wxSpinCtrl *LeftChars;
		wxSpinCtrl *RNDchars;
		wxTextCtrl *WxCRC1;
		wxTextCtrl *WxCRC0;
		wxTextCtrl *FinalString;
		wxTextCtrl *StartString;
		wxStaticText *WxStaticText11;
		wxStaticText *WxStaticText3;
		wxButton *AlphaCharSet;
		wxButton *AlphaNumCharSet;
		wxButton *TresCharSet;
		wxTextCtrl *Code0;
		wxButton *WxButton4;
		wxStaticText *WxStaticText18;
		wxTextCtrl *CharSet;
		wxStaticText *WxStaticText17;
		wxStaticText *WxStaticText16;
		wxStaticText *WxStaticText15;
		wxTextCtrl *MidString2;
		wxStaticText *WxStaticText13;
		wxButton *WxButton3;
		wxTextCtrl *Code;
		wxStaticText *WxStaticText10;
		wxTextCtrl *Code4;
		wxTextCtrl *Code3;
		wxTextCtrl *Code2;
		wxTextCtrl *Code1;
		wxStaticText *WxStaticText9;
		wxTextCtrl *TrailString;
		wxStaticText *WxStaticText8;
		wxTextCtrl *LeadString;
		wxStaticText *WxStaticText7;
		wxButton *WxButton2;
		wxTextCtrl *CRCinput;
		wxStaticText *WxStaticText6;
		wxTextCtrl *CRCoutput;
		wxStaticText *WxStaticText5;
		wxButton *WxButton1;
		wxTextCtrl *TextString;
		wxStaticText *WxStaticText4;
		wxStaticText *WxStaticText2;
		wxStaticText *WxStaticText1;
		wxStaticBox *WxStaticBox2;
		wxStaticBox *WxStaticBox1;
		wxPanel *WxPanel1;
		wxStatusBar *WxStatusBar1;
		////GUI Control Declaration End
		
	private:
		//Note: if you receive any error with these enum IDs, then you need to
		//change your old form code that are based on the #define control IDs.
		//#defines may replace a numeric value for the enum names.
		//Try copy and pasting the below block in your old form header files.
		enum
		{
			////GUI Enum Control ID Start
			ID_REQSTRING2 = 1066,
			ID_WXSTATICTEXT14 = 1065,
			ID_REPEATS = 1064,
			ID_REPEAT = 1062,
			ID_STRICT = 1061,
			ID_WXSTATICTEXT12 = 1060,
			ID_LEFTCHARS = 1059,
			ID_RNDCARS = 1058,
			ID_WXCRC1 = 1057,
			ID_WXCRC0 = 1056,
			ID_FINALSTRING = 1055,
			ID_STARTSTRING = 1054,
			ID_WXSTATICTEXT11 = 1053,
			ID_WXSTATICTEXT3 = 1052,
			ID_ALPHACHARSET = 1051,
			ID_ALPHANUMCHARSET = 1050,
			ID_TRESCHARSET = 1049,
			ID_CODE0 = 1048,
			ID_WXBUTTON4 = 1047,
			ID_WXSTATICTEXT18 = 1044,
			ID_CHARSET = 1043,
			ID_WXSTATICTEXT17 = 1042,
			ID_WXSTATICTEXT16 = 1040,
			ID_WXSTATICTEXT15 = 1038,
			ID_MIDSTRING2 = 1035,
			ID_WXSTATICTEXT13 = 1034,
			ID_WXBUTTON3 = 1031,
			ID_CODE = 1028,
			ID_WXSTATICTEXT10 = 1027,
			ID_CODE4 = 1026,
			ID_CODE3 = 1025,
			ID_CODE2 = 1024,
			ID_CODE1 = 1023,
			ID_WXSTATICTEXT9 = 1022,
			ID_TRAILSTRING = 1021,
			ID_WXSTATICTEXT8 = 1020,
			ID_LEADSTRING = 1019,
			ID_WXSTATICTEXT7 = 1018,
			ID_WXBUTTON2 = 1017,
			ID_CRCINPUT = 1016,
			ID_WXSTATICTEXT6 = 1015,
			ID_CRCOUTPUT = 1014,
			ID_WXSTATICTEXT5 = 1012,
			ID_WXBUTTON1 = 1011,
			ID_TEXTSTRING = 1010,
			ID_WXSTATICTEXT4 = 1009,
			ID_WXSTATICTEXT2 = 1007,
			ID_WXSTATICTEXT1 = 1006,
			ID_WXSTATICBOX2 = 1004,
			ID_WXSTATICBOX1 = 1003,
			ID_WXPANEL1 = 1002,
			ID_WXSTATUSBAR1 = 1001,
			////GUI Enum Control ID End
			ID_DUMMY_VALUE_ //don't remove this value unless you have other enum values
		};
		
	private:
		void OnClose(wxCloseEvent& event);
		void CreateGUIControls();
};

#endif
